## vowpal-wabbit 8.5.0.dfsg1

=== R/r.vw/DESCRIPTION ===
Package: r.vw
Type: Package
Title: interface between R and Vowpal Wabbit
Version: 0.1
Date: 2015-10-07
Authors@R: person("First", "Last", email = "first.last@example.com", role = c("aut", "cre"))
Description: More about what it does (maybe more than one line)
License: BSD
LazyData: TRUE
Imports: pROC,
    data.table,
    ggplot2

=== demo/movielens/Makefile ===
SHELL=/bin/zsh
VW=../../vowpalwabbit/vw

.SECONDARY:

all:
	@cat README.md

shootout: $(foreach what,linear lrq lrqdropout lrqdropouthogwild,$(what).print)

clean:
	rm -f $(wildcard *results*) $(wildcard *.vw) $(wildcard *.model.txt) $(wildcard *.pdf)

ml-%.zip:
	@echo "downloading movielens $*"
	@wget http://files.grouplens.org/datasets/movielens/ml-$*.zip

ml-%/ratings.dat: ml-%.zip
	@rm -rf ml-$*
	@unzip -qq $<
	@(test -d ml-10M100K && mv -f ml-10M100K ml-10m) || true
	@rm -rf __MACOSX
	@touch ml-$*/*

ml-%.ratings.train.vw: ml-%/ratings.dat
	@echo -n "preprocessing movielens $* ..."
	@./ratings2vw ml-$*.ratings.pre.train.vw ml-$*.ratings.test.vw $<
	@perl -ne 'BEGIN { srand 8675309; }; 		\
	           1; print join "\t", rand (), $$_;' 	\
	      ml-$*.ratings.pre.train.vw | sort -k1 |	\
	      cut -f2- > ml-$*.ratings.train.vw
	@rm -f ml-$*.ratings.pre.train.vw
	@echo " complete"

%.test.vw: %.train.vw
	@true

%.print: %.results
	@printf "%s test MAE is %3.3f\n" $* $$(cat $*.results)

#---------------------------------------------------------------------
#               linear model (no interaction terms)
#---------------------------------------------------------------------

linear.results: ml-1m.ratings.test.vw ml-1m.ratings.train.vw
	@echo "****************************************************"
	@echo "*   training linear model (no interaction terms)   *"
	@echo "****************************************************"
	@echo
	@${VW} --loss_function quantile -l 1 -b 24 --passes 100 	\
	  -k --cache_file $@.cache -d $(word 2,$+) --holdout_off	\
	  --adaptive --invariant -f $@.model
	@echo "****************************************************"
	@echo "*   testing linear model (no interaction terms)    *"
	@echo "****************************************************"
	@echo
	@${VW} --loss_function quantile -t -i $@.model 			\
	  -d $(word 1,$+) -p						\
	  >(perl -lane '$$s+=abs(($$F[0]-$$F[1])); } { 			\
			1; print $$s/$$.;' > $@)
	@echo "****************************************************"
	@echo "*   saving human readable model (--invert_hash)    *"
	@echo "****************************************************"
	@echo
	@${VW} -i $@.model -t --invert_hash $@.model.txt -d $(word 2,$+)
	@rm -f $@.cache $@.model

#---------------------------------------------------------------------
#               low-rank interaction model (without dropout)
#---------------------------------------------------------------------

lrq.results: ml-1m.ratings.test.vw ml-1m.ratings.train.vw
	@echo "*********************************************************"
	@echo "* training low-rank interaction model (without dropout) *"
	@echo "*                                                       *"
	@echo "* vw --lrq um7 ...                                      *"
	@echo "*********************************************************"
	@echo
	@${VW} --loss_function quantile -l 0.1 -b 24 --passes 100 	\
	  -k --cache_file $@.cache -d $(word 2,$+) --holdout_off	\
	  --power_t 0.333 --l2 1.25e-7 --lrq um7 --adaptive --invariant -f $@.model
	@echo "********************************************************"
	@echo "* testing low-rank interaction model (without dropout) *"
	@echo "********************************************************"
	@echo
	@${VW} --loss_function quantile -t -i $@.model 			\
	  -d $(word 1,$+) -p						\
	  >(perl -lane '$$s+=abs(($$F[0]-$$F[1])); } { 			\
			1; print $$s/$$.;' > $@)
	@echo "****************************************************"
	@echo "*   saving human readable model (--invert_hash)    *"
	@echo "****************************************************"
	@echo
	@${VW} -i $@.model -t --invert_hash $@.model.txt -d $(word 2,$+)
	@rm -f $@.cache $@.model

#---------------------------------------------------------------------
#               low-rank interaction model (with dropout)
#---------------------------------------------------------------------

lrqdropout.results: ml-1m.ratings.test.vw ml-1m.ratings.train.vw
	@echo "******************************************************"
	@echo "* training low-rank interaction model (with dropout) *"
	@echo "*                                                    *"
	@echo "* vw --lrq um14 --lrqdropout ...                     *"
	@echo "******************************************************"
	@echo
	@${VW} --loss_function quantile -l 0.45 -b 24 --passes 100 	\
	  -k --cache_file $@.cache -d $(word 2,$+) --holdout_off	\
	  --lrq um14 --lrqdropout --adaptive --invariant -f $@.model
	@echo "*****************************************************"
	@echo "* testing low-rank interaction model (with dropout) *"
	@echo "*****************************************************"
	@echo
	@${VW} --loss_function quantile -t -i $@.model 			\
	  -d $(word 1,$+) -p						\
	  >(perl -lane '$$s+=abs(($$F[0]-$$F[1])); } { 			\
			1; print $$s/$$.;' > $@)
	@echo "****************************************************"
	@echo "*   saving human readable model (--invert_hash)    *"
	@echo "****************************************************"
	@echo
	@${VW} -i $@.model -t --invert_hash $@.model.txt -d $(word 2,$+)
	@rm -f $@.cache $@.model

movie_dendrogram.pdf: lrqdropout.results
	@echo "*******************************************************"
	@echo "* Generating movie clustering based on latent factors *"
	@echo "*         (Requires an installation of R)             *"
	@echo "*******************************************************"
	@grep ^lrq^m $<.model.txt | tr '^' ':' > $<.model.csv
	@Rscript visualize_factors.R
	@rm -f $@.model.csv

#---------------------------------------------------------------------
#               low-rank interaction model (with dropout)
#                  (HOGWILD training mode)
#---------------------------------------------------------------------

lrqdropouthogwild.results: ml-1m.ratings.test.vw ml-1m.ratings.train.vw do-lrq-hogwild
	@echo "******************************************************"
	@echo "* training low-rank interaction model (with dropout) *"
	@echo "*      (HOGWILD training mode)                       *"
	@echo "*                                                    *"
	@echo "* vw --lrq um14 --lrqdropout ...                     *"
	@echo "******************************************************"
	@echo
	@./do-lrq-hogwild $@.model
	@echo "*****************************************************"
	@echo "* testing low-rank interaction model (with dropout) *"
	@echo "*****************************************************"
	@echo
	@${VW} --loss_function quantile -t -i $@.model 			\
	  -d $(word 1,$+) -p						\
	  >(perl -lane '$$s+=abs(($$F[0]-$$F[1])); } { 			\
			1; print $$s/$$.;' > $@)

.PHONY: all clean shootout

=== demo/normalized/Makefile ===
SHELL=/bin/bash
VW=../../vowpalwabbit/vw

.SECONDARY:

all:
	@cat README.md

datasets := bank census covertype CTslice MSD shuttle

all.results.pre: $(foreach what,$(datasets),$(what).best $(what).nonormbest)
	@printf "%20.20s\t%9s\t%9s\t%9s\t%9s\n" "Dataset" "NAG eta^*" "NAG loss" "AG eta^*" "AG loss"

all.results: all.results.pre $(foreach what,$(datasets),$(what).resultsprint)

SHUFFLE='BEGIN { srand 69; };					\
         $$i = int rand 100000;					\
	 print $$b[$$i] if $$b[$$i];				\
	 $$b[$$i] = $$_; } { print grep { defined $$_ } @b;'

#---------------------------------------------------------------------
#                           bank marketing
#
# normalization really helps.  The columns have units of euros, seconds,
# days, and years; in addition there are categorical variables.
#---------------------------------------------------------------------

bank.zip:
	@echo "downloading bank ..." 1>&2
	@wget -q -O - 							     \
	     http://archive.ics.uci.edu/ml/machine-learning-databases/00222/$@ \
	  > $@

bank.preprocess.data.gz: bank.zip
	@echo "preprocessing bank ..." 1>&2
	@zcat $< 2>/dev/null |						\
	  perl -MScalar::Util -F';' -lane '$$l = pop @F; $$p = ($$l =~ /no/) ? -1 : 1; print "$$p $$p|f ", join " ", map { $$isn = Scalar::Util::looks_like_number ($$F[$$_]); $$F[$$_] =~ s/^\s+//; $$F[$$_] =~ s/\s+$$//; $$F[$$_] =~ s/\W/_/g unless $$isn; $$isn ? "@{[$$_+1]}:$$F[$$_]" : "@{[$$_+1]}_$$F[$$_]" } grep { $$F[$$_] =~ /\w/ && ( ! Scalar::Util::looks_like_number ($$F[$$_]) || $$F[$$_] > 0 ) } (0 .. $$#F)' |								\
	perl -e 'BEGIN { srand 69; }; print map { $$_->[1] } sort { $$a->[0] <=> $$b->[0] } map { [ rand (), $$_ ] } <>;' | gzip                        \
	> $@

bank.data: bank.preprocess.data.gz

bank.%.nonormlearn: bank.preprocess.data.gz
	 @${VW} --loss_function logistic -b 22 -q ff -l $* $<		\
	   --adaptive --invariant					\
	   -p >(perl -lane '						\
		  1; ++$$n; $$l+=1.0 if $$F[0] * $$F[1] < 0; } 		\
		  1; { printf "average loss = %f\t%u\t%u\n", $$l/$$n, $$l, $$n;')

bank.%.learn: bank.preprocess.data.gz
	 @${VW} --loss_function logistic -b 22 -q ff -l $* $<		\
	   -p >(perl -lane '						\
		  1; ++$$n; $$l+=1.0 if $$F[0] * $$F[1] < 0; } 		\
		  1; { printf "average loss = %f\t%u\t%u\n", $$l/$$n, $$l, $$n;')

bankbestmin=1e-2
bankbestmax=10
banknonormbestmin=1e-8
banknonormbestmax=1e-3
banktimeestimate=1

#---------------------------------------------------------------------
#                              covertype
#---------------------------------------------------------------------

covtype.data.gz:
	@echo "downloading covertype ..."
	@wget -q -O -                                                    	\
	  http://archive.ics.uci.edu/ml/machine-learning-databases/covtype/$@ 	\
	  > $@

covtype.preprocess.data.gz: covtype.data.gz
	@echo "preprocessing covertype ..." 1>&2
	@perl -F',' 							\
	    -lane '$$l = pop @F; print "$$l $$l|f ", map { "$$_:$$F[$$_] "} grep { $$F[$$_] } (0 .. $$#F)' <(zcat $<) |                  \
	perl -e 'BEGIN { srand 69; }; print map { $$_->[1] } sort { $$a->[0] <=> $$b->[0] } map { [ rand (), $$_ ] } <>;' | gzip                        \
	> $@

covertype.data: covtype.preprocess.data.gz

covertype.%.nonormlearn: covtype.preprocess.data.gz
	${VW} --adaptive --invariant -b 22 --hash all -q ff --oaa 7 -l $* -d $<

covertype.%.learn: covtype.preprocess.data.gz
	${VW} -b 22 --hash all -q ff --oaa 7 -l $* -d $<

covertypebestmin=1e-2
covertypebestmax=10
covertypenonormbestmin=1e-8
covertypenonormbestmax=1e-5
covertypetimeestimate=5

#---------------------------------------------------------------------
#                        million song database
#
# normalization is helpful.
#---------------------------------------------------------------------

YearPredictionMSD.bz2:
	@echo "downloading MSD ..." 1>&2
	@wget -q -O - 								\
	  http://www.csie.ntu.edu.tw/~cjlin/libsvmtools/datasets/regression/$@ 	\
	  > $@

year.preprocess.data.gz: YearPredictionMSD.bz2
	@echo "preprocessing MSD ..." 1>&2
	@perl -lane 'splice @F, 1, 0, "$$F[0]|f"; print join " ", @F' 	\
	  <(bzcat $<) |							\
        perl -ne $(SHUFFLE)						\
	| gzip > $@

MSD.data: year.preprocess.data.gz

MSD.%.learn: year.preprocess.data.gz
	@zcat $< |							\
	perl -lane '$$F[0] -= 1998; print join " ", @F' |		\
	${VW} -q ff -l $* 						\
	   -p >(perl -lane '						\
	   	  1; BEGIN { $$max = 0; $$min = 3000; };		\
		  1; ++$$n; $$l += ($$F[0] + 1998 - $$F[1])**2;  	\
		  1; $$max = $$F[1] if $$max < $$F[1];			\
		  1; $$min = $$F[1] if $$min > $$F[1];			\
		  1; } { $$c = $$l / ($$max - $$min)**2;		\
		  1; printf "average loss = %f\t%.3f\t%.3f\t%.3f\t%.3f\n", $$c/$$n, $$l, $$n, $$min, $$max;')

MSD.%.nonormlearn: year.preprocess.data.gz
	@zcat $< |							\
	perl -lane '$$F[0] -= 1998; print join " ", @F' |		\
	${VW} --adaptive --invariant -q ff -l $* 			\
	   -p >(perl -lane '						\
	   	  1; BEGIN { $$max = 0; $$min = 3000; };		\
		  1; ++$$n; $$l += ($$F[0] + 1998 - $$F[1])**2;  	\
		  1; $$max = $$F[1] if $$max < $$F[1];			\
		  1; $$min = $$F[1] if $$min > $$F[1];			\
		  1; } { $$c = $$l / ($$max - $$min)**2;		\
		  1; printf "average loss = %f\t%.3f\t%.3f\t%.3f\t%.3f\n", $$c/$$n, $$l, $$n, $$min, $$max;')

MSDbestmin=1e-2
MSDbestmax=10
MSDnonormbestmin=1e-8
MSDnonormbestmax=1e-5
MSDtimeestimate=15

#---------------------------------------------------------------------
#                         census-income (KDD)
#---------------------------------------------------------------------

census-income.data.gz:
	@echo "downloading census ..." 1>&2
	@wget -q -O - 							\
	    http://archive.ics.uci.edu/ml/machine-learning-databases/census-income-mld/$@									\
	  > $@

census-income.preprocess.data.gz: census-income.data.gz
	@echo "preprocessing census ..." 1>&2
	@zcat $< |							\
	  perl -MScalar::Util -F',' -lane '$$l = pop @F; $$p = $$l =~ /-/ ? -1 : 1; print "$$p $$p|f ", join " ", map { $$isn = Scalar::Util::looks_like_number ($$F[$$_]); $$F[$$_] =~ s/^\s+//; $$F[$$_] =~ s/\s+$$//; $$F[$$_] =~ s/\W/_/g unless $$isn; $$isn ? "@{[$$_+1]}:$$F[$$_]" : "@{[$$_+1]}_$$F[$$_]" } grep { $$F[$$_] =~ /\w/ && ( ! Scalar::Util::looks_like_number ($$F[$$_]) || $$F[$$_] > 0 ) } (0 .. $$#F)' |								\
	perl -e 'BEGIN { srand 69; }; print map { $$_->[1] } sort { $$a->[0] <=> $$b->[0] } map { [ rand (), $$_ ] } <>;' | gzip                        \
	> $@

census.data: census-income.preprocess.data.gz

census.%.nonormlearn: census-income.preprocess.data.gz
	 @${VW} --hash all --loss_function logistic -q ff -l $* 	\
	   --adaptive --invariant $< 					\
	   -p >(perl -lane '						\
		  1; ++$$n; $$l+=1.0 if $$F[0] * $$F[1] < 0; } 		\
		  1; { printf "average loss = %f\t%u\t%u\n", $$l/$$n, $$l, $$n;')

census.%.learn: census-income.preprocess.data.gz
	 @${VW} --hash all --loss_function logistic -q ff -l $* $<	\
	   -p >(perl -lane '						\
		  1; ++$$n; $$l+=1.0 if $$F[0] * $$F[1] < 0; } 		\
		  1; { printf "average loss = %f\t%u\t%u\n", $$l/$$n, $$l, $$n;')

censusbestmin=1e-2
censusbestmax=10
censusnonormbestmin=1e-8
censusnonormbestmax=1e-4
censustimeestimate=5

#---------------------------------------------------------------------
#                          Statlog (Shuttle)
#---------------------------------------------------------------------

shuttle.trn.Z:
	@echo "downloading Shuttle ..." 1>&2
	@wget -q -O - 							\
	  http://archive.ics.uci.edu/ml/machine-learning-databases/statlog/shuttle/$@									\
	  > $@

shuttle.preprocess.data.gz: shuttle.trn.Z
	@echo "preprocessing Shuttle ..." 1>&2
	@zcat shuttle.trn.Z | 						\
	perl -lane '$$l = pop @F; print "$$l |f ", join " ", map { "@{[$$_+1]}:$$F[$$_]" } grep { $$F[$$_] } (0 .. $$#F)' | 				\
	perl -e 'BEGIN { srand 69; }; print map { $$_->[1] } sort { $$a->[0] <=> $$b->[0] } map { [ rand (), $$_ ] } <>;' | gzip                        \
	 > $@

shuttle.data: shuttle.preprocess.data.gz

shuttle.%.nonormlearn: shuttle.preprocess.data.gz
	${VW} --adaptive --invariant -b 22 --hash all -q ff --oaa 7 -l $* -d $<

shuttle.%.learn: shuttle.preprocess.data.gz
	${VW} -b 22 --hash all -q ff --oaa 7 -l $* -d $<

shuttlebestmin=1e-2
shuttlebestmax=10
shuttlenonormbestmin=1e-8
shuttlenonormbestmax=1e-3
shuttletimeestimate=1

#---------------------------------------------------------------------
#                              CT slices
#
# normalization doesn't help much
#---------------------------------------------------------------------

slice_localization_data.zip:
	@echo "downloading CTslice ..." 1>&2
	@wget -q -O - 							    \
	    http://archive.ics.uci.edu/ml/machine-learning-databases/00206/$@ \
	  > $@

slice_localization.preprocess.data.gz: slice_localization_data.zip
	@echo "preprocessing CTslice ..." 1>&2
	@zcat $< | perl -F',' -lane 'BEGIN { scalar <>; }; shift @F; $$l = pop @F; $$l =~ s/\r//; $$l -= 47; print "$$l $$l|f ", join " ", map { ($$F[$$_] eq "-0.25") ? "$${_}_outside" : "$$_:$$F[$$_]" } grep { $$F[$$_] } (0 .. $$#F)' | perl -e 'BEGIN { srand 69; }; print map { $$_->[1] } sort { $$a->[0] <=> $$b->[0] } map { [ rand (), $$_ ] } <>;' | gzip        	\
	> $@

CTslice.data: slice_localization.preprocess.data.gz

CTslice.%.nonormlearn: slice_localization.preprocess.data.gz
	 @${VW} --adaptive --invariant -b 22 --hash all -q ff -l $* $<  \
	   -p >(perl -lane '						\
	   	  1; BEGIN { $$max = -3000; $$min = 3000; };		\
		  1; ++$$n; $$l += ($$F[0] - $$F[1])**2;  		\
		  1; $$max = $$F[1] if $$max < $$F[1];			\
		  1; $$min = $$F[1] if $$min > $$F[1];			\
		  1; } { $$c = $$l / ($$max - $$min)**2;		\
		  1; printf "average loss = %f\t%.3f\t%.3f\t%.3f\t%.3f\n", $$c/$$n, $$l, $$n, $$min, $$max;')

CTslice.%.learn: slice_localization.preprocess.data.gz
	 @${VW} -b 22 --hash all -q ff -l $* $<				\
	   -p >(perl -lane '						\
	   	  1; BEGIN { $$max = -3000; $$min = 3000; };		\
		  1; ++$$n; $$l += ($$F[0] - $$F[1])**2;  		\
		  1; $$max = $$F[1] if $$max < $$F[1];			\
		  1; $$min = $$F[1] if $$min > $$F[1];			\
		  1; } { $$c = $$l / ($$max - $$min)**2;		\
		  1; printf "average loss = %f\t%.3f\t%.3f\t%.3f\t%.3f\n", $$c/$$n, $$l, $$n, $$min, $$max;')

CTslicebestmin=1e-2
CTslicebestmax=10
CTslicenonormbestmin=1e-5
CTslicenonormbestmax=1
CTslicetimeestimate=15

#---------------------------------------------------------------------
#                           common routines
#---------------------------------------------------------------------

%.best: %.data
	@echo "($*) searching for best in-hindsight learning rate for NAG" 1>&2
	@printf "WARNING: this step takes about %s minutes\n" $($*timeestimate)
	@./hypersearch $($*bestmin) $($*bestmax) '$(MAKE)' '$*.%.learn' > $@

%.nonormbest: %.data
	@echo "($*) searching for best in-hindsight learning rate for AG" 1>&2
	@printf "WARNING: this step takes about %s minutes\n" $($*timeestimate)
	@./hypersearch $($*nonormbestmin) $($*nonormbestmax) '$(MAKE)' '$*.%.nonormlearn' > $@

%.resultsprint:
	@printf "%20.20s\t%9.3g\t%9.3g\t%9.3g\t%9.3g\n" "$*" $$(cut -f1 $*.best) $$(cut -f2 $*.best) $$(cut -f1 $*.nonormbest) $$(cut -f2 $*.nonormbest)

only.%: %.best %.nonormbest all.results.pre %.resultsprint
	@true

.PHONY: all all.results all.results.pre

=== demo/recall_tree/ltcb/Makefile ===
SHELL=/bin/zsh

.SECONDARY:

numlabels=80000

all: enwik8.train.vw.gz

sweep_oaa%: sweep_oaa%.vw enwik8.test.vw.gz
	(time vw -t -i $(word 1,$^) <(zcat $(word 2,$^) | perl -ne '($$l,$$b)=split /\s/, $$_, 2; $$l = $(numlabels)+2-$$l; $$l = 1+$* if $$l > $*; print "$$l $$b"')) > $@ 2>&1

sweep_oaa%.vw: enwik8.train.vw.gz
	(time vw -f $@ --oaa $$((1+$*)) --oaa_subsample 1000 <(zcat $< | perl -ne '($$l,$$b)=split /\s/, $$_, 2; $$l = $(numlabels)+2-$$l; print "$$l $$b" if $$l <= $*') -q bc --cubic bcd -b 30 --loss_function logistic -l 1) > sweep_oaa$*.train 2>&1

full_inorder_log_multihyper%.vw: bits=32
full_inorder_log_multihyper%.vw: enwik9.inorder.train.vw.gz
	perl -le 'BEGIN { srand $*; };                  \
              1; $$eta = 0.1 + 3.9 * rand ();           \
              1; $$nodes = int (10000 + 40000 * rand ());    	\
	      1; $$loss = rand () > 0.5 ? "squared" : "logistic"; \
              1; $$swap = 2 ** (int (4 * rand ()));	\
              1; $$quad = rand () > 0.5 ? "z" : "b";    \
              1; $$cubic = rand () > 0.5 ? "z" : "b";   \
              1; print join " ", $$eta, $$nodes, $$loss, $$swap, $$quad, $$cubic;' | \
        while read eta nodes loss swap quad cubic;		\
	  do (							\
	    echo $$eta $$nodes $$loss $$swap $$quad $$cubic;	\
	    time vw -f $@ --log_multi $$(( $(numlabels)+1 )) $< -q c$$quad --cubic cd$$cubic -b $(bits) --loss_function $$loss -l $$eta --swap_resistance $$swap; 							\
	  ) > full_inorder_log_multihyper$*.train 2>&1;							\
	  done	  

full_log_multihyper%.vw: bits=32
full_log_multihyper%.vw: enwik9.train.vw.gz
	perl -le 'BEGIN { srand $*; };                  \
              1; $$eta = 0.1 + 3.9 * rand ();           \
              1; $$nodes = int (10000 + 40000 * rand ());    	\
	      1; $$loss = rand () > 0.5 ? "squared" : "logistic"; \
              1; $$swap = 2 ** (int (4 * rand ()));	\
              1; $$quad = rand () > 0.5 ? "z" : "b";    \
              1; $$cubic = rand () > 0.5 ? "z" : "b";   \
              1; print join " ", $$eta, $$nodes, $$loss, $$swap, $$quad, $$cubic;' | \
        while read eta nodes loss swap quad cubic;		\
	  do (							\
	    echo $$eta $$nodes $$loss $$swap $$quad $$cubic;	\
	    time vw -f $@ --log_multi $$(( $(numlabels)+1 )) $< -q c$$quad --cubic cd$$cubic -b $(bits) --loss_function $$loss -l $$eta --swap_resistance $$swap; 							\
	  ) > full_log_multihyper$*.train 2>&1;							\
	  done	  

full_log_multihyper%: full_log_multihyper%.vw enwik9.test.vw.gz
	(time vw -t -i $^) > $@ 2>&1

log_multihyper%: bits=30
log_multihyper%: enwik8.train.vw.gz
	perl -le 'BEGIN { srand $*; };                  \
              1; $$eta = 0.1 + 3.9 * rand ();           \
              1; $$nodes = int (10000 + 40000 * rand ());    	\
	      1; $$loss = rand () > 0.5 ? "squared" : "logistic"; \
              1; $$swap = 2 ** (int (4 * rand ()));	\
              1; $$quad = rand () > 0.5 ? "z" : "b";    \
              1; $$cubic = rand () > 0.5 ? "z" : "b";   \
              1; print join " ", $$eta, $$nodes, $$loss, $$swap, $$quad, $$cubic;' | \
        while read eta nodes loss swap quad cubic;		\
	  do (							\
	    echo $$eta $$nodes $$loss $$swap $$quad $$cubic;	\
	    vw --log_multi $$(( $(numlabels)+1 )) $< -q c$$quad --cubic cd$$cubic -b $(bits) --loss_function $$loss -l $$eta --swap_resistance $$swap; 							\
	  ) > $@ 2>&1;							\
	  done	  

full_inorder_hyper%.vw: enwik9.inorder.train.vw.gz
	perl -le 'BEGIN { srand $*; };                  \
              1; $$eta = 0.1 + 3.9 * rand ();           \
              1; $$depth = int (11 + 6 * rand ());      \
              1; $$mc = int (20 + 80 * rand ());        \
              1; $$log_hyper = log (0.01) + (log (10) - log (0.01)) * rand (); \
              1; $$rr = rand () > 0.5 ? 1 : 0;          \
	      1; $$no = rand () > 0.5 ? 1 : 0;		\
              1; $$dq = rand () > 0.5 ? "z" : "b";      \
              1; $$cubic = rand () > 0.5 ? "z" : "b";   \
              1; $$pf = rand () > 0.5 ? "z" : "b";   	\
              1; $$pfc = rand () > 0.5 ? "z" : "b";   	\
              1; print join " ", $$eta, $$depth, $$mc, exp ($$log_hyper), $$rr, $$no, $$dq, $$cubic, $$pf, $$pfc;' | \
        while read eta depth mc hyper rr no dq cubic pf pfc; 		\
          do (                                          		\
            echo $$eta $$depth $$mc $$hyper $$rr $$no $$dq $$cubic $$pf $$pfc; \
	    time vw -f $@ $< -b 32 --recall_tree $$(( $(numlabels)+1 )) -l $$eta --max_depth $$depth --max_candidates $$mc --bern_hyper $$hyper --randomized_routing $$rr --node_only $$no -q c$$dq --cubic cd$$cubic -q '\x88'$$pf --cubic '\x88'c$$pfc; \
	  ) > full_inorder_hyper$*.train 2>&1;					\
	  done	  

full_hyper%: full_hyper%.vw enwik9.test.vw.gz
	(time vw -t -i $^) > $@ 2>&1

full_hyper%.vw: enwik9.train.vw.gz
	perl -le 'BEGIN { srand $*; };                  \
              1; $$eta = 0.1 + 3.9 * rand ();           \
              1; $$depth = int (11 + 6 * rand ());      \
              1; $$mc = int (20 + 80 * rand ());        \
              1; $$log_hyper = log (0.01) + (log (10) - log (0.01)) * rand (); \
              1; $$rr = rand () > 0.5 ? 1 : 0;          \
	      1; $$no = rand () > 0.5 ? 1 : 0;		\
              1; $$dq = rand () > 0.5 ? "z" : "b";      \
              1; $$cubic = rand () > 0.5 ? "z" : "b";   \
              1; $$pf = rand () > 0.5 ? "z" : "b";   	\
              1; $$pfc = rand () > 0.5 ? "z" : "b";   	\
              1; print join " ", $$eta, $$depth, $$mc, exp ($$log_hyper), $$rr, $$no, $$dq, $$cubic, $$pf, $$pfc;' | \
        while read eta depth mc hyper rr no dq cubic pf pfc; 		\
          do (                                          		\
            echo $$eta $$depth $$mc $$hyper $$rr $$no $$dq $$cubic $$pf $$pfc; \
	    time vw -f $@ $< -b 32 --recall_tree $$(( $(numlabels)+1 )) -l $$eta --max_depth $$depth --max_candidates $$mc --bern_hyper $$hyper --randomized_routing $$rr --node_only $$no -q c$$dq --cubic cd$$cubic -q '\x88'$$pf --cubic '\x88'c$$pfc; \
	  ) > full_hyper$*.train 2>&1;					\
	  done	  

full_oaa_hyper%: full_oaa_hyper%.vw enwik9.test.vw.gz
	(time vw -t -i $^) > $@ 2>&1

# hogwild fails with more bits ... some kind of deadlock issue :(
full_oaa_hyper%.vw: bits=30
full_oaa_hyper%.vw: enwik9.train.vw.gz
	perl -le 'BEGIN { srand $*; };                  \
              1; $$eta = 0.1 + 3.9 * rand ();           \
              1; print join " ", $$eta;' | \
        while read eta; 		\
          do (                                          		\
            echo $$eta; \
	    unbuffer ./do-oaa-hogwild $< -f $@ --oaa $$(( $(numlabels)+1 )) --oaa_subsample 2000 -q bc --cubic bcd -b $(bits) --loss_function logistic -l $$eta; \
	  ) |& > full_oaa_hyper$*.train 2>&1;           \
	  done	  

oaa_hyper%: bits=30
oaa_hyper%: enwik8.train.vw.gz
	perl -le 'BEGIN { srand $*; };                  \
              1; $$eta = 0.1 + 3.9 * rand ();           \
              1; print join " ", $$eta;' | \
        while read eta; 		\
          do (                                          		\
            echo $$eta; \
	    vw $< --oaa $$(( $(numlabels)+1 )) --oaa_subsample 2000 -q bc --cubic bcd -b $(bits) --loss_function logistic -l $$eta; \
	  ) |& > $@ 2>&1;						\
	  done	  

hyper%: enwik8.train.vw.gz
	perl -le 'BEGIN { srand $*; };                  \
              1; $$eta = 0.1 + 3.9 * rand ();           \
              1; $$depth = int (11 + 6 * rand ());      \
              1; $$mc = int (20 + 80 * rand ());        \
              1; $$log_hyper = log (0.01) + (log (10) - log (0.01)) * rand (); \
              1; $$rr = rand () > 0.5 ? 1 : 0;          \
	      1; $$no = rand () > 0.5 ? 1 : 0;		\
              1; $$dq = rand () > 0.5 ? "z" : "b";      \
              1; $$cubic = rand () > 0.5 ? "z" : "b";   \
              1; $$pf = rand () > 0.5 ? "z" : "b";   	\
              1; $$pfc = rand () > 0.5 ? "z" : "b";   	\
              1; print join " ", $$eta, $$depth, $$mc, exp ($$log_hyper), $$rr, $$no, $$dq, $$cubic, $$pf, $$pfc;' | \
        while read eta depth mc hyper rr no dq cubic pf pfc; 		\
          do (                                          		\
            echo $$eta $$depth $$mc $$hyper $$rr $$no $$dq $$cubic $$pf $$pfc; \
	    vw $< -b 30 --recall_tree $$(( $(numlabels)+1 )) -l $$eta --max_depth $$depth --max_candidates $$mc --bern_hyper $$hyper --randomized_routing $$rr --node_only $$no -q c$$dq --cubic cd$$cubic -q '\x88'$$pf --cubic '\x88'c$$pfc; \
	  ) > $@ 2>&1;							\
	  done	  

sweep_recall_tree%: sweep_recall_tree%.vw enwik8.test.vw.gz
	(time vw -t -i $^) > $@ 2>&1

sweep_recall_tree%.vw: bern_hyper=1
sweep_recall_tree%.vw: enwik8.train.vw.gz
	(time vw -f $@ --recall_tree $$(( $(numlabels)+1 )) $< -q bc --cubic bcd -b 30 --loss_function logistic -l 1 -q '\x88'b --cubic '\x88'bc --max_candidates $* --bern_hyper $(bern_hyper)) > sweep_recall_tree$*.train 2>&1 

recall_tree%: recall_tree%.vw enwik%.test.vw.gz
	vw -t -i $^ 

recall_tree%.vw: vwextra=
recall_tree%.vw: bits=32
recall_tree%.vw: enwik%.train.vw.gz
	vw -f $@ --recall_tree $$(( $(numlabels)+1 )) $< -q bc --cubic bcd -b $(bits) --loss_function logistic -l 1 -q '\x88'b --cubic '\x88'bc $(vwextra) #--link glf1 --randomized_routing $(randomized_routing) 

log_multi%: log_multi%.vw enwik%.test.vw.gz
	time vw -t -i $^ 

log_multi%.vw: enwik%.train.vw.gz
	time vw -f $@ --log_multi $$(( $(numlabels)+1 )) $< -q bc --cubic bcd -b 32 --loss_function logistic 

# NB: 30 instead of 32 here ... hogwild increases memory usage (?)
oaahogwild%.vw: enwik%.train.vw.gz
	./do-oaa-hogwild $< -f $@ --oaa $$(( $(numlabels)+1 )) --oaa_subsample 2000 -q bc --cubic bcd -b 30 --loss_function logistic -l 1 

oaahogwild%: enwik%.test.vw.gz oaahogwild%.vw
	./do-oaa-hogwild $< -i $(word 2,$^) -t

enwik%.zip:
	wget -c http://mattmahoney.net/dc/enwik$*.zip

enwik%.freq: enwik%.zip
	zcat enwik$*.zip | \
	  perl ./wikifil.pl | \
	  perl -lane 'foreach (@F) { $$c{$$_}++; } } \
	           1; { while (($$k, $$v) = each %c) { print "$$k\t$$v"; }' | \
	  sort -k2rn > $@

enwik%.train.vw.gz: enwik%.freq enwik%.zip
	zcat enwik$*.zip | \
	  perl ./wikifil.pl | \
	  perl -ne 'BEGIN { srand 69; }; \
	         1; if (10 * rand () < 1) { print STDERR $$_; \
		 1; } else { print STDOUT $$_; }' \
	  2> >(perl ./gendata.pl enwik$*.freq $(numlabels) 10000000 | gzip > enwik$*.test.vw.gz) \
	  > >(perl ./gendata.pl enwik$*.freq $(numlabels) 10000000 | gzip > enwik$*.train.vw.gz)

# NB: shufbuf size of 1 => in order processing
enwik%.inorder.train.vw.gz: enwik%.freq enwik%.zip
	zcat enwik$*.zip | \
	  perl ./wikifil.pl | \
	  perl -ne 'BEGIN { srand 69; }; \
	         1; if (10 * rand () < 1) { print STDERR $$_; \
		 1; } else { print STDOUT $$_; }' \
	  2> >(perl ./gendata.pl enwik$*.freq $(numlabels) 1 | gzip > enwik$*.inorder.test.vw.gz) \
	  > >(perl ./gendata.pl enwik$*.freq $(numlabels) 1 | gzip > enwik$*.inorder.train.vw.gz)

=== debian/changelog ===
vowpal-wabbit (8.5.0.dfsg1-1) unstable; urgency=medium

  * Fresh upstream release
  * debian/control
    - added rapidjson-dev to build-depends
    - boosted policy to 4.1.3
    - boosted compat/debhelper to 9
    - "optional" priority instead of "extra" for -dbg to please lintian
  * debian/*.install
    - libraries are installed under usr/lib/ARCH/ now

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 08 Feb 2018 16:21:28 -0500

=== debian/control ===
Source: vowpal-wabbit
Section: science
Priority: optional
Maintainer: Yaroslav Halchenko <debian@onerussian.com>
Build-Depends: debhelper (>= 9),
               dh-autoreconf,
               libboost-program-options-dev,
			   libboost-python-dev,
			   rapidjson-dev,
               help2man,
               zlib1g-dev,
			   markdown, html2text,
Standards-Version: 4.1.3
Homepage: http://hunch.net/~vw/
Vcs-Browser: http://github.com/yarikoptic/vowpal_wabbit
Vcs-Git: git://github.com/yarikoptic/vowpal_wabbit.git -b debian

Package: vowpal-wabbit
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libvw0 (= ${binary:Version})
Suggests: vowpal-wabbit-doc
Description: fast and scalable online machine learning algorithm
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing

Package: libvw0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: fast and scalable online machine learning algorithm - dynamic library
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing
 .
 This package contains vowpal-wabbit's dynamic libraries.

Package: libvw-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libvw0 (= ${binary:Version})
Description: fast and scalable online machine learning algorithm - development files
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing
 .
 This package contains development files needed to compile and link programs
 which use vowpal-wabbit's libraries.

Package: vowpal-wabbit-dbg
Section: debug
Priority: optional
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, vowpal-wabbit (= ${binary:Version})
Description: fast and scalable online machine learning algorithm - debug files
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing
 .
 This package contains debug symbols for the binaries shipped by vowpal-wabbit
 packages.

Package: vowpal-wabbit-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: vowpal-wabbit
Description: fast and scalable online machine learning algorithm - documentation
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing
 .
 This package contains examples (tests) for vowpal-wabbit.
